/* 
	Programiranje (C) -- 01.09.2003.
	1. zadatak
*/

#include <stdio.h>
#include <stdlib.h>

int main ( void )
{
	int n, **matrica, red, stupac, suma;
	int magicni;

	/* ucitaj N */
	scanf ("%d", &n);

	/* alociraj mjesto za NxN matricu */
	matrica=(int **) malloc (n*sizeof (int *));
	for (red=0; red<n; red++)
		matrica[red]=(int *) malloc (n*sizeof (int));

	/* ucitaj matricu sa tipkovnice */
	for (red=0; red<n; red++)
		for (stupac=0; stupac<n; stupac++)
			scanf ("%d", &matrica[red][stupac]);

	/* provjeri je li ova matrica magicni kvadrat  *
	 * prvo pretpostavimo da je                    */
	magicni=1;
		
	/* prvo trebamo izracunati sumu prvog redka */
	suma=0;
	for (stupac=0; stupac<n; stupac++)
		suma+=matrica[0][stupac];
		
	/* treba provjeriti je li suma u preostalim recima jednaka *
	 *  sumi prvog retka -- ako nije, ovo nije magicni kvadrat */
	for (red=0; red<n && magicni; red++)
	{
		int sumareda=0;
		for (stupac=0; stupac<n; stupac++)
			sumareda+=matrica[red][stupac];

		if (sumareda != suma)
			magicni=0;		
	}

	/* i sad isto za stupce */
	for (stupac=0; stupac<n && magicni; stupac++)
	{
		int sumastupca=0;
		for (red=0; red<n; red++)
			sumastupca+=matrica[red][stupac];

		if (sumastupca != suma)
			magicni=0;		
	}

	printf ("Ucitana matrica ");
	if (magicni)
		printf ("je");
	else
		printf ("nije");
	printf (" magicni kvadrat.\n");

	/* dealokacija memorije */
	for (red=0; red<n; red++)
		free (matrica[red]);
	free (matrica);

	return 0;
}
