/* 
	Programiranje (C) -- 01.09.2003.
	5. zadatak
*/

typedef struct __node
{
	char *ime, momcad[4];
	unsigned int bodovi;
	double zarada;
	struct __node *next;
} cvor;

cvor *montoya (cvor *pocetak)
{
	cvor *trenutni=pocetak, *prethodni=NULL;
	int pozicija=1;

	/* sve dok trenutni cvor ne pokazuje na Montoyu */
	while (trenutni!=NULL && strcmp (trenutni->ime, "Juan Pablo Montoya"))
	{
		pozicija++;
		/* cuvamo pokazivac na prethodni cvor -- ovo nam treba za *
		 * kasnije premjestanje Motoye na pocetak liste           */
		prethodni=trenutni; 
		trenutni=trenutni->next; /* pomicemo se na iduci cvor u listi */
	}

	/* ako nema Montoye, dosli smo do kraja liste -- izlazimo iz funkcije */
	if (trenutni==NULL)
	{
		printf ("U listi nema podataka o Montoyi.\n");
		return pocetak;
	}
	
	/* nasli smo Montoyu i ispisujemo na kojem je mjestu u listi */
	printf ("Montoya je na %d. mjestu u listi.\n", pozicija);

	/* ako je vec na prvoj poziciji, izlazimo iz funkcije */
	if (pozicija==1)
		return pocetak;

	/* u protivnom, spajamo onog tko je ispred njega sa onim       *
	 * iza njega (uocite da ovaj iza njega moze i smije biti NULL, *
	 * tj. Montoya je mozda bio zadnji u listi)                    *
	 * Nakon toga stavljamo Montoyu na pocetak tako da stavimo da  *
	 * iza njega dolazi cvor na pocetku liste.                     */
	prethodni->next=trenutni->next;
	trenutni->next=pocetak;

	return trenutni;
}
