/* 
	Programiranje (C) -- 01.09.2003.
	4. zadatak
*/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>

int main (int broj_parametara, char **parametar)
{
	int i, j;
	char slovo;

	/* za svako slovo abecede provjeravamo da li se nalazi u svim rijecima */
	for (slovo='a'; slovo<='z'; slovo++)
	{
		int svi_imaju=1; /* pretpostavljamo prvo da sve rijeci imaju slovo */ 
		
		/* for-petlja ide od 1 jer je nulti parametar ime programa */
		for (i=1; i<broj_parametara && svi_imaju; i++)
		{
			int ima=0; /* prvo pretpostavljamo da i-ta rijec nema slovo */

			/* kroz sve znakove i-te rijeci trazimo slovo */
			for (j=0; parametar[i][j]!='\0' && !ima; j++)
				if (tolower (parametar[i][j])==slovo)
					ima=1; /* pronasli smo slovo u i-toj rijeci */

			if (!ima) /* ako nismo nasli slovo u i-toj rijeci */
				svi_imaju=0; /* postoji rijec u kojoj nema slova */
		}

		if (svi_imaju) /* ako sve rijeci imaju slovo, onda ga ispisujemo */
			printf ("%c ", slovo);
	}

	printf ("\n");

	return 0;
}
